--Start ACtivity

function CliffBaseAssault:StartActivity()
	print("START! --CliffBaseAssault:StartActivity()!")

	self.BrainhuntLZ = SceneMan.Scene:GetArea("LZ Brainhunt")
	self.BrainGuardArea = SceneMan.Scene:GetArea("Brain Guard")
	self.PlayerBrainVault = SceneMan.Scene:GetArea("PlayerBrainVault")
	self.Zone = SceneMan.Scene:GetArea("CliffBaseArea")
	self.PlayerLZ = SceneMan.Scene:GetArea("LZ Team 1")
	self.DummyLZ = SceneMan.Scene:GetArea("LZ Team 2")
	self.AmbushLZ = SceneMan.Scene:GetArea("LZ Ambush")
	self.PatrolArea = SceneMan.Scene:GetArea("Patrol Area")
	self.FightPhase = { NOFIGHT = 0, BEGINFIGHT = 1, CAVEFIGHT = 2, ROOFFIGHT = 3, BRAINFIGHT = 4 }
	self.CurrentFightPhase = self.FightPhase.NOFIGHT
	self.DummySpawnTimer = Timer()
	self.MessageTimer = Timer()
	self.DummySpawnInterval = 24000
	--	self.AlarmInterval = 28000;
	self.braindead = {}
	self.AssignedBrains = {}
	--	self.PlayerGold = 5000;
	-- Set up teams
	self.CPUTeam = Activity.TEAM_2
	self.PlayerTeam = Activity.TEAM_1
	self.RogueTeam = -1
	self.CPUTechName = "Dummy.rte"
	--	self.MOIDCountMax = 180;

	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.AlarmInterval = 60000
		self.PlayerGold = 10000
		self.CrateFunds = 1000
		self.MOIDCountMax = 132
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.AlarmInterval = 45000
		self.PlayerGold = 5000
		self.CrateFunds = 1000
		self.MOIDCountMax = 156
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.AlarmInterval = 30000
		self.PlayerGold = 4000
		self.CrateFunds = 600
		self.MOIDCountMax = 185
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.AlarmInterval = 25000
		self.PlayerGold = 3000
		self.CrateFunds = 400
		self.MOIDCountMax = 200
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.AlarmInterval = 20000
		self.PlayerGold = 2000
		self.CrateFunds = 500
		self.MOIDCountMax = 225
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.AlarmInterval = 15000
		self.PlayerGold = 1000
		self.CrateFunds = 250
		self.MOIDCountMax = 250
	end

	self:SetLZArea(self.PlayerTeam, self.PlayerLZ)

	-- Create the keys and place in the scene

	self.YellowCase = CreateMOSRotating("Yellow Key Case", "CliffBaseAssault.rte")
	self.YellowCase.Pos = Vector(3012, 912)
	self.YellowCase.Team = self.CPUTeam
	MovableMan:AddParticle(self.YellowCase)

	self.BlueCase = CreateMOSRotating("Blue Key Case", "CliffBaseAssault.rte")
	self.BlueCase.Pos = Vector(2976, 336)
	self.BlueCase.Team = self.CPUTeam
	MovableMan:AddParticle(self.BlueCase)

	self.RedCase = CreateMOSRotating("Red Key Case", "CliffBaseAssault.rte")
	self.RedCase.Pos = Vector(2544, 924)
	self.RedCase.Team = self.CPUTeam
	MovableMan:AddParticle(self.RedCase)

	--Set up players

	for player = 0, self.PlayerCount - 1 do
		-- Check if we already have a brain assigned
		if not self:GetPlayerBrain(player) then
			self.braindead[player] = false
			-- Create brain here and alter all his neccessary properties
			local brain = CreateActor("Brain Case", "Base.rte")
			-- Actor location on the scene. X=0 , Y=0 is the upper left corner of the map. Greater X is to the right.
			-- Greater Y is to the bottom.
			brain.Pos = Vector(416.4 + player * 30, 902.4)
			-- Add created brain to the array of assigned actors
			self.AssignedBrains[player] = brain

			-- Let the spawn into the world, passing ownership
			MovableMan:AddActor(brain)
			-- Set the found brain to be the selected actor at start
			self:SetPlayerBrain(brain, player)
			SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player)
			-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
			self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player)
			-- Select brain as current actor
			self:SwitchToActor(brain, player, self.PlayerTeam)
		end
	end

	-- Set up AI modes for the Actors that have been added to the scene by the scene definition
	for actor in MovableMan.AddedActors do
		if actor.Team == self.CPUTeam then
			actor.AIMode = Actor.AIMODE_SENTRY
			if actor.PresetName == "Dummy Controller" then
				self.CPUBrain = actor
			end
		end
	end

	self:SetTeamFunds(self.PlayerGold, self.PlayerTeam)
	self.DummySpawnTimer:Reset()
end

-- Pause Activity

function CliffBaseAssault:PauseActivity(pause)
	print("PAUSE! -- CliffBaseAssault:PauseActivity()!")
end

-- End Activity

function CliffBaseAssault:EndActivity()
	print("END! -- CliffBaseAssault:EndActivity()!")
	-- Play sad music if no humans are left
	if self:HumanBrainCount() == 0 then
		AudioMan:ClearMusicQueue()
		AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/udiedfinal.ogg", 2, -1.0)
		AudioMan:QueueSilence(10)
		AudioMan:QueueMusicStream("Base.rte/Music/dBSoundworks/ccambient4.ogg")
	else
		-- But if humans are left, then play happy music!
		AudioMan:ClearMusicQueue()
		AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/uwinfinal.ogg", 2, -1.0)
		AudioMan:QueueSilence(10)
		AudioMan:QueueMusicStream("Base.rte/Music/dBSoundworks/ccambient4.ogg")
	end
end

-- Update Activity

function CliffBaseAssault:UpdateActivity()
	self:ClearObjectivePoints()
	if self.CurrentFightPhase == self.FightPhase.NOFIGHT then
		self:PhaseNoFight()
	elseif self.CurrentFightPhase == self.FightPhase.BEGINFIGHT then
		self:PhaseOne()
	elseif self.CurrentFightPhase == self.FightPhase.CAVEFIGHT then
		self:PhaseTwo()
	elseif self.CurrentFightPhase == self.FightPhase.ROOFFIGHT then
		self:PhaseThree()
	elseif self.CurrentFightPhase == self.FightPhase.BRAINFIGHT then
		self:PhaseFour()
	end

	--Check for defeat conditions
	self:DoBrainSelection()
	self:YSortObjectivePoints()
end

-- Brain selection and gameover check

function CliffBaseAssault:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player)
			local brain = self:GetPlayerBrain(player)
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player)
				local newBrain = MovableMan:GetUnassignedBrain(team)
				--Found new barin actor, assign and continue
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player)
					self:SwitchToActor(newBrain, player, team)
				else
					-- All brains of this team are dead. Show fail reason
					FrameMan:SetScreenText("You lost your brain!", player, 100, -1, false)
					-- Set the flag that this player is brainless
					self.braindead[player] = true

					-- Now see if all brains of self player's team are dead, and if so, end the game
					-- Show Fail\Win banner to participating teams.
					self.WinnerTeam = self:OtherTeam(team)
					-- Game over
					ActivityMan:EndActivity()
				end
			else
				-- Update the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
				self:SetObservationTarget(brain.Pos, player)
			end --
		end
	end
	if MovableMan:IsActor(self.CPUBrain) then
		self:AddObjectivePoint(
			"Destroy!",
			self.CPUBrain.AboveHUDPos + Vector(0, -16),
			Activity.TEAM_1,
			GameActivity.ARROWDOWN
		)
	else
		self.WinnerTeam = self.PlayerTeam
		ActivityMan:EndActivity()
	end
end

-- Phase No Fight ... This is the initial mission phase. "Historicaly" it is called "no fight".

function CliffBaseAssault:PhaseNoFight()
	-- Show a fixed objective mark with down arrow
	self:AddObjectivePoint("Place brain here!", Vector(416.4, 890), self.PlayerTeam, GameActivity.ARROWDOWN)

	-- Enumerate all player brains and determine if one of them is inside the area. If it is, advance to next phase
	for player = 0, self.PlayerCount - 1 do
		if self.PlayerBrainVault:IsInside(self.AssignedBrains[player].Pos) then
			self:AdvanceToOne()
		end
	end
end

-- No Fight -> Begin Fight

function CliffBaseAssault:AdvanceToOne()
	self.CurrentFightPhase = self.FightPhase.BEGINFIGHT
	for player = 0, self.PlayerCount - 1 do
		-- Clear previous message and reset message timer
		self:ResetMessageTimer(player)
		FrameMan:ClearScreenText(player)
		-- Put message text
		FrameMan:SetScreenText("Find the YELLOW KEY!", player, 0, 5000, true)
		self.DummySpawnTimer:Reset()
	end
end

-- begin Fight ... where the dropships spawn

function CliffBaseAssault:PhaseOne()
	-- MARK THE OBJECTIVES
	self:ClearObjectivePoints()
	if not (self.ActivityState == Activity.OVER) then
		-- Control box
		if MovableMan:IsParticle(self.YellowCase) then
			self:AddObjectivePoint(
				"Destroy for Yellow Key!",
				self.YellowCase.AboveHUDPos,
				Activity.TEAM_1,
				GameActivity.ARROWDOWN
			)
		else
			self.YellowCase = nil
			self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.CrateFunds, self.PlayerTeam)
			self:AdvanceToTwo()
		end
	end

	if MovableMan:GetTeamMOIDCount(self.CPUTeam) < self.MOIDCountMax then
		-- Check if MOID limit is reached then check if spawn timer is reached
		if self.DummySpawnTimer:IsPastSimMS(self.AlarmInterval) then
			local ship = CreateACDropShip("Dummy Dropship", self.CPUTechName)
			local actor = nil
			local weapon = nil
			for i = 0, 1 do
				actor = CreateAHuman("Dummy", self.CPUTechName)
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

				actor.AIMode = Actor.AIMODE_GOTO
				actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end
			for i = 0, 1 do
				actor = CreateAHuman("Dummy", self.CPUTechName)
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

				actor.AIMode = Actor.AIMODE_GOTO
				actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end
			for i = 0, 1 do
				if math.random() < 0.3 then
					actor = CreateAHuman("Whitebot", "Techion.rte")
				else
					actor = CreateAHuman("Dummy", self.CPUTechName)
				end
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

				actor.AIMode = Actor.AIMODE_BRAINHUNT
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end

			ship.Pos = Vector(self.DummyLZ:GetRandomPoint().X, 0)
			ship.Team = self.CPUTeam
			ship:SetControllerMode(Controller.CIM_AI, -1)
			MovableMan:AddActor(ship)
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player)
				FrameMan:ClearScreenText(player)
				-- Put message text
				FrameMan:SetScreenText("Reinforcements incoming!!", player, 500, 5000, true)
			end
			self.DummySpawnTimer:Reset()
		end
	end
end

-- No Fight -> Phase Two

function CliffBaseAssault:AdvanceToTwo()
	for actor in MovableMan.Actors do
		if actor.PresetName == "Yellow Door B" then
			actor:GibThis()
		end
	end

	for player = 0, self.PlayerCount - 1 do
		self:ResetMessageTimer(player)
		FrameMan:ClearScreenText(player)
		-- Put message text
		FrameMan:SetScreenText("You got the YELLOW KEY! Find the BLUE KEY!", player, 500, 5000, true)
	end
	--[[
	if self.MessageTimer:IsPastSimMS(5000) then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			-- Put message text
			FrameMan:SetScreenText("DANGER! AMBUSH!!", player, 500, 5000, true);
		end
	end
]]
	--

	local ship = CreateACDropShip("Dummy Dropship", self.CPUTechName)
	local actor = nil
	local weapon = nil
	for i = 0, 1 do
		actor = CreateAHuman("Dummy", self.CPUTechName)
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

		actor.AIMode = Actor.AIMODE_BRAINHUNT
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end
	for i = 0, 1 do
		actor = CreateAHuman("Dummy", self.CPUTechName)
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

		actor.AIMode = Actor.AIMODE_GOTO
		actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end
	for i = 0, 1 do
		if math.random() < 0.6 then
			actor = CreateAHuman("Techion Silver Man", "Techion.rte")
		else
			actor = CreateAHuman("Dummy", self.CPUTechName)
		end
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", "Techion.rte"))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))
		actor.AIMode = Actor.AIMODE_GOTO
		actor:AddAISceneWaypoint(Vector(self.BrainGuardArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end

	ship.Pos = Vector(self.AmbushLZ:GetRandomPoint().X, 0)
	ship.Team = self.CPUTeam
	ship:SetControllerMode(Controller.CIM_AI, -1)
	MovableMan:AddActor(ship)

	--brainhnter

	local ship = CreateACRocket("Rocket MK1", "Base.rte")
	local actor = nil
	local weapon = nil
	for i = 0, 1 do
		actor = CreateAHuman("Dummy", self.CPUTechName)
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

		actor.AIMode = Actor.AIMODE_BRAINHUNT
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end
	for i = 0, 1 do
		if math.random() < 0.6 then
			actor = CreateAHuman("Techion Silver Man", "Techion.rte")
		else
			actor = CreateAHuman("Dummy", self.CPUTechName)
		end
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", "Techion.rte"))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

		actor.AIMode = Actor.AIMODE_BRAINHUNT
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end

	ship.Pos = Vector(self.BrainhuntLZ:GetRandomPoint().X, 0)
	ship.Team = self.CPUTeam
	ship:SetControllerMode(Controller.CIM_AI, -1)
	MovableMan:AddActor(ship)

	self.CurrentFightPhase = self.FightPhase.CAVEFIGHT
end

-- Phase 2 -> Get Blue Key

function CliffBaseAssault:PhaseTwo()
	self:ClearObjectivePoints()
	if not (self.ActivityState == Activity.OVER) then
		-- Control box
		if MovableMan:IsParticle(self.BlueCase) then
			self:AddObjectivePoint(
				"Destroy for Blue Key!",
				self.BlueCase.AboveHUDPos,
				Activity.TEAM_1,
				GameActivity.ARROWDOWN
			)
		else
			self.BlueCase = nil
			self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.CrateFunds, self.PlayerTeam)
			self:AdvanceToThree()
		end
	end

	if MovableMan:GetTeamMOIDCount(self.CPUTeam) < self.MOIDCountMax then
		-- Check if MOID limit is reached then check if spawn timer is reached
		if self.DummySpawnTimer:IsPastSimMS(self.AlarmInterval) then
			local ship = CreateACDropShip("Dummy Dropship", self.CPUTechName)
			local actor = nil
			local weapon = nil
			for i = 0, 1 do
				actor = CreateAHuman("Dummy", self.CPUTechName)
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

				actor.AIMode = Actor.AIMODE_GOTO
				actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end
			for i = 0, 1 do
				actor = CreateAHuman("Dummy", self.CPUTechName)
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

				actor.AIMode = Actor.AIMODE_GOTO
				actor:AddAISceneWaypoint(
					Vector(self.BrainGuardArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y)
				)
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end
			for i = 0, 1 do
				if math.random() < 0.4 then
					actor = CreateAHuman("Techion Silver Man", "Techion.rte")
				else
					actor = CreateAHuman("Dummy", self.CPUTechName)
				end
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", "Techion.rte"))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

				actor.AIMode = Actor.AIMODE_BRAINHUNT
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end

			ship.Pos = Vector(self.AmbushLZ:GetRandomPoint().X, 0)
			ship.Team = self.CPUTeam
			ship:SetControllerMode(Controller.CIM_AI, -1)
			MovableMan:AddActor(ship)
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player)
				FrameMan:ClearScreenText(player)
				-- Put message text
				FrameMan:SetScreenText("Reinforcements incoming!!", player, 500, 5000, true)
			end
			self.DummySpawnTimer:Reset()
		end
	end
end

-- No Fight -> Phase Three

function CliffBaseAssault:AdvanceToThree()
	print("Moving to Phase Three")

	for actor in MovableMan.Actors do
		if actor.PresetName == "Blue Door B" then
			actor:GibThis()
		end
	end

	for player = 0, self.PlayerCount - 1 do
		self:ResetMessageTimer(player)
		FrameMan:ClearScreenText(player)
		-- Put message text
		FrameMan:SetScreenText("You got the BLUE KEY! Find the RED KEY!", player, 500, 5000, true)
	end
	--[[
	if self.MessageTimer:IsPastSimMS(5000) then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			-- Put message text
			FrameMan:SetScreenText("DANGER! AMBUSH!!", player, 500, 5000, true);
		end
	end
]]
	--
	local ship = CreateACDropShip("Dummy Dropship", self.CPUTechName)
	local actor = nil
	local weapon = nil
	for i = 0, 1 do
		actor = CreateAHuman("Dummy", self.CPUTechName)
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

		actor.AIMode = Actor.AIMODE_BRAINHUNT
		actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end
	for i = 0, 1 do
		actor = CreateAHuman("Dummy", self.CPUTechName)
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

		actor.AIMode = Actor.AIMODE_BRAINHUNT
		actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end
	for i = 0, 1 do
		if math.random() < 0.8 then
			actor = CreateAHuman("Techion Silver Man", "Techion.rte")
		else
			actor = CreateAHuman("Dummy", self.CPUTechName)
		end
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", "Techion.rte"))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

		actor.AIMode = Actor.AIMODE_GOTO
		actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end

	ship.Pos = Vector(2976, 0)
	ship.Team = self.CPUTeam
	ship:SetControllerMode(Controller.CIM_AI, -1)
	MovableMan:AddActor(ship)

	--brainhunters

	local ship = CreateACRocket("Rocket MK1", "Base.rte")
	local actor = nil
	local weapon = nil
	for i = 0, 1 do
		actor = CreateAHuman("Dummy", self.CPUTechName)
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

		actor.AIMode = Actor.AIMODE_BRAINHUNT
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end
	for i = 0, 1 do
		if math.random() < 0.6 then
			actor = CreateAHuman("Techion Silver Man", "Techion.rte")
		else
			actor = CreateAHuman("Dummy", self.CPUTechName)
		end
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", "Techion.rte"))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

		actor.AIMode = Actor.AIMODE_BRAINHUNT
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end

	ship.Pos = Vector(self.BrainhuntLZ:GetRandomPoint().X, 0)
	ship.Team = self.CPUTeam
	ship:SetControllerMode(Controller.CIM_AI, -1)
	MovableMan:AddActor(ship)

	self.CurrentFightPhase = self.FightPhase.ROOFFIGHT
end

-- Phase 3 -> Get Red key

function CliffBaseAssault:PhaseThree()
	-- MARK THE OBJECTIVES
	self:ClearObjectivePoints()
	if not (self.ActivityState == Activity.OVER) then
		-- Control box
		if MovableMan:IsParticle(self.RedCase) then
			self:AddObjectivePoint(
				"Destroy for Red Key!",
				self.RedCase.AboveHUDPos,
				Activity.TEAM_1,
				GameActivity.ARROWDOWN
			)
		else
			self.RedCase = nil
			self:SetTeamFunds(self:GetTeamFunds(self.PlayerTeam) + self.CrateFunds, self.PlayerTeam)
			self:AdvanceToFour()
		end
	end

	if MovableMan:GetTeamMOIDCount(self.CPUTeam) < self.MOIDCountMax then
		-- Check if MOID limit is reached then timer
		if self.DummySpawnTimer:IsPastSimMS(self.AlarmInterval) then
			local ship = CreateACDropShip("Dummy Dropship", self.CPUTechName)
			local actor = nil
			local weapon = nil
			for i = 0, 1 do
				actor = CreateAHuman("Dummy", self.CPUTechName)
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

				actor.AIMode = Actor.AIMODE_GOTO
				actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end
			for i = 0, 1 do
				actor = CreateAHuman("Whitebot", "Techion.rte")
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

				actor.AIMode = Actor.AIMODE_GOTO
				actor:AddAISceneWaypoint(
					Vector(self.BrainGuardArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y)
				)
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end
			for i = 0, 1 do
				if math.random() < 0.6 then
					actor = CreateAHuman("Techion Silver Man", "Techion.rte")
				else
					actor = CreateAHuman("Dummy", self.CPUTechName)
				end
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", "Techion.rte"))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

				actor.AIMode = Actor.AIMODE_GOTO
				actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end

			if math.random() < 0.5 then
				ship.Pos = Vector(self.DummyLZ:GetRandomPoint().X, 0)
			else
				ship.Pos = Vector(self.AmbushLZ:GetRandomPoint().X, 0)
			end
			ship.Team = self.CPUTeam
			ship:SetControllerMode(Controller.CIM_AI, -1)
			MovableMan:AddActor(ship)
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player)
				FrameMan:ClearScreenText(player)
				-- Put message text
				FrameMan:SetScreenText("Reinforcements incoming!!", player, 500, 5000, true)
			end
			self.DummySpawnTimer:Reset()
		end
	end
end

-- No Fight -> Phase Four

function CliffBaseAssault:AdvanceToFour()
	print("Moving to Phase Four")

	for actor in MovableMan.Actors do
		if actor.PresetName == "Red Door B" then
			actor:GibThis()
		end
	end

	for player = 0, self.PlayerCount - 1 do
		self:ResetMessageTimer(player)
		FrameMan:ClearScreenText(player)
		-- Put message text
		FrameMan:SetScreenText("You got the RED KEY! Destroy the DUMMY CONTROLLER!", player, 500, 5000, true)
	end
	--[[
	if self.MessageTimer:IsPastSimMS(5000) then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			-- Put message text
			FrameMan:SetScreenText("Destroy the DUMMY CONTROLLER!", player, 500, 5000, true);
		end
	end
]]
	--
	--ambushlz

	local ship = CreateACDropShip("Dummy Dropship", self.CPUTechName)
	local actor = nil
	local weapon = nil
	for i = 0, 1 do
		actor = CreateAHuman("Dummy", self.CPUTechName)
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

		actor.AIMode = Actor.AIMODE_GOTO
		actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end
	for i = 0, 1 do
		actor = CreateAHuman("Techion Silver Man", "Techion.rte")
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", "Techion.rte"))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

		actor.AIMode = Actor.AIMODE_GOTO
		actor:AddAISceneWaypoint(Vector(self.BrainGuardArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end
	for i = 0, 1 do
		if math.random() < 0.6 then
			actor = CreateAHuman("Techion Silver Man", "Techion.rte")
		else
			actor = CreateAHuman("Dummy", self.CPUTechName)
		end
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", "Techion.rte"))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

		actor.AIMode = Actor.AIMODE_BRAINHUNT
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end

	ship.Pos = Vector(self.AmbushLZ:GetRandomPoint().X, 0)
	ship.Team = self.CPUTeam
	ship:SetControllerMode(Controller.CIM_AI, -1)
	MovableMan:AddActor(ship)

	--dummylz

	local ship = CreateACDropShip("Dummy Dropship", self.CPUTechName)
	local actor = nil
	local weapon = nil
	for i = 0, 1 do
		actor = CreateAHuman("Dummy", self.CPUTechName)
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", self.CPUTechName))

		actor.AIMode = Actor.AIMODE_GOTO
		actor:AddAISceneWaypoint(Vector(self.BrainGuardArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end
	for i = 0, 1 do
		actor = CreateAHuman("Whitebot", "Techion.rte")
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

		actor.AIMode = Actor.AIMODE_BRAINHUNT
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end
	for i = 0, 1 do
		if math.random() < 0.8 then
			actor = CreateAHuman("Techion Silver Man", "Techion.rte")
		else
			actor = CreateAHuman("Dummy", self.CPUTechName)
		end
	end
	if IsAHuman(actor) then
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", "Techion.rte"))
		actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

		actor.AIMode = Actor.AIMODE_BRAINHUNT
		actor.Team = self.CPUTeam
		ship:AddInventoryItem(actor)
	end

	ship.Pos = Vector(self.DummyLZ:GetRandomPoint().X, 0)
	ship.Team = self.CPUTeam
	ship:SetControllerMode(Controller.CIM_AI, -1)
	MovableMan:AddActor(ship)
	self.CurrentFightPhase = self.FightPhase.BRAINFIGHT
end

-- Phase 4 -> Destroy brain

function CliffBaseAssault:PhaseFour()
	if MovableMan:GetTeamMOIDCount(self.CPUTeam) < self.MOIDCountMax then
		-- Check if MOID limit is reached then timer
		if self.DummySpawnTimer:IsPastSimMS(self.AlarmInterval) then
			local ship = CreateACDropShip("Dummy Dropship", self.CPUTechName)
			local actor = nil
			local weapon = nil
			for i = 0, 1 do
				actor = CreateAHuman("Dummy", self.CPUTechName)
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

				actor.AIMode = Actor.AIMODE_BRAINHUNT
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end
			for i = 0, 1 do
				actor = CreateAHuman("Dummy", self.CPUTechName)
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", self.CPUTechName))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

				actor.AIMode = Actor.AIMODE_GOTO
				actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end
			for i = 0, 1 do
				if math.random() < 0.6 then
					actor = CreateAHuman("Techion Silver Man", "Techion.rte")
				else
					actor = CreateAHuman("Dummy", self.CPUTechName)
				end
			end
			if IsAHuman(actor) then
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Primary", "Techion.rte"))
				actor:AddInventoryItem(RandomHDFirearm("Weapons - Secondary", "Techion.rte"))

				actor.AIMode = Actor.AIMODE_GOTO
				actor:AddAISceneWaypoint(Vector(self.PatrolArea:GetRandomPoint().X, self.PatrolArea:GetRandomPoint().Y))
				actor.Team = self.CPUTeam
				ship:AddInventoryItem(actor)
			end

			if math.random() < 0.5 then
				ship.Pos = Vector(self.DummyLZ:GetRandomPoint().X, 0)
			else
				ship.Pos = Vector(self.AmbushLZ:GetRandomPoint().X, 0)
			end
			ship.Team = self.CPUTeam
			ship:SetControllerMode(Controller.CIM_AI, -1)
			MovableMan:AddActor(ship)
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player)
				FrameMan:ClearScreenText(player)
				-- Put message text
				FrameMan:SetScreenText("Reinforcements incoming!!", player, 500, 5000, true)
			end
			self.DummySpawnTimer:Reset()
		end
	end
end
